﻿using System;
using System.Web.UI;
using System.Workflow.Runtime;
using WorkflowCore;
using WorkflowCore.Logging;
using WorkflowCore.Data;

//////////////////////////////////////////////////////////////////////
// Created by Michael Kennedy
// http://www.michaelckennedy.net
// Copyright Michael Kennedy 2008.
// Part of the HRWorkflow sample application featured in MSDN Magazine.
//

namespace HRWorkflow
{
	public partial class AssignJob : Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if ( !IsPostBack )
			{
				Employee employee = Database.FindEmployee(QueryStringData.GetWorkflowId());
				LabelPerson.Text = employee.Name + " (age " + employee.Age + ")";

				TraceDT.Add( "Page loaded, pulling employee from 'db'.",
					QueryStringData.GetWorkflowId(), this.GetType() );
			}
		}

		protected void ButtonSubmit_Click(object sender, EventArgs e)
		{
			Guid id = QueryStringData.GetWorkflowId();
			WorkflowInstance wfInst = Global.WorkflowRuntime.GetWorkflow( id );

			Job job = new Job();
			job.JobTitle = DropDownListJob.SelectedValue;
			job.Salary = Convert.ToDouble( TextBoxSalary.Text );

			TraceDT.Add( "Page processing assignment, pulling employee from 'db', proposed job {0}.",
							   QueryStringData.GetWorkflowId(), this.GetType(), job.JobTitle );

			wfInst.EnqueueItem( AssignJobActivity.QUEUE_NAME, job, null, null );

			buttonSubmit.Enabled = false;

			LabelMessage.Text = "<br /><br />Ok, now pretend you're the prospective employee who got an email saying" +
			                    " there is a new recruit. Click <a href='ConfirmJob.aspx?id=" + id + "'>here</a>.";
		}
	}
}