﻿using System;
using System.Workflow.Runtime;
using WorkflowCore;
using WorkflowCore.Logging;
using WorkflowCore.Data;

//////////////////////////////////////////////////////////////////////
// Created by Michael Kennedy
// http://www.michaelckennedy.net
// Copyright Michael Kennedy 2008.
// Part of the HRWorkflow sample application featured in MSDN Magazine.
//

namespace HRWorkflow
{
	public partial class ConfirmJob : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
			{
				Employee employee = Database.FindEmployee( QueryStringData.GetWorkflowId() );
				LabelPerson.Text = employee.Name;
				LabelJob.Text = employee.Job;
				LabelSalary.Text = employee.Salary.ToString( "C0" );

				TraceDT.Add( "Page loading with employee: {0}.",
									QueryStringData.GetWorkflowId(), this.GetType(), employee.Name );
			}
		}

		protected void LinkButtonYes_Click(object sender, EventArgs e)
		{
			TraceDT.Add( "Page processing employee response: {0}.",
							  QueryStringData.GetWorkflowId(), this.GetType(), "accepted" );

			Guid id = QueryStringData.GetWorkflowId();
			WorkflowInstance wfInst = Global.WorkflowRuntime.GetWorkflow( id );
			wfInst.EnqueueItem( ConfirmJobActivity.QUEUE_NAME, "Yes", null, null );

			Response.Redirect( "Finished.aspx?id="+id );
		}

		protected void LinkButtonNo_Click(object sender, EventArgs e)
		{
			TraceDT.Add( "Page processing employee response: {0}.",
							  QueryStringData.GetWorkflowId(), this.GetType(), "decliened" );

			Guid id = QueryStringData.GetWorkflowId();
			WorkflowInstance wfInst = Global.WorkflowRuntime.GetWorkflow( id );
			wfInst.EnqueueItem( ConfirmJobActivity.QUEUE_NAME, "No", null, null );

			Response.Redirect( "Finished.aspx?id=" + id );
		}
	}
}
