﻿using System;
using WorkflowCore;
using System.Workflow.Runtime;
using WorkflowCore.Logging;
using WorkflowCore.Data;

//////////////////////////////////////////////////////////////////////
// Created by Michael Kennedy
// http://www.michaelckennedy.net
// Copyright Michael Kennedy 2008.
// Part of the HRWorkflow sample application featured in MSDN Magazine.
//

namespace HRWorkflow
{
	public partial class GatherEmployeeData : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
			{
				TraceDT.Add( "Page loaded for new recruit.", 
					QueryStringData.GetWorkflowId(), this.GetType() );
			}
		}

		protected void Button1_Click(object sender, EventArgs e)
		{
			Button1.Enabled = false;
			Employee employee = new Employee();
			employee.Name = TextBoxName.Text.Trim();
			employee.Age = int.Parse( TextBoxAge.Text );

			Guid id = QueryStringData.GetWorkflowId();
			WorkflowInstance wfInst = Global.WorkflowRuntime.GetWorkflow( id );
			wfInst.EnqueueItem( GatherEmployeeInfoActivity.QUEUE_NAME, employee, null, null );

			TraceDT.Add( "New employee data gathered: {0}, {1}.", 
				QueryStringData.GetWorkflowId(), this.GetType(), employee.Name, employee.Age );

			LabelMessage.Text = "<br /><br />Ok, now pretend you're the boss who got an email saying there is a new recruit. Click <a href='AssignJob.aspx?id=" + id + "'>here</a>.";
		}
	}
}
