﻿using System;
using System.Text;
using System.Web.UI;
using WorkflowCore.Logging;
using System.Web;

//////////////////////////////////////////////////////////////////////
// Created by Michael Kennedy
// http://www.michaelckennedy.net
// Copyright Michael Kennedy 2008.
// Part of the HRWorkflow sample application featured in MSDN Magazine.
//

namespace HRWorkflow
{
	public partial class WorkflowViewer : Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
		}

		public void timerTick(object sender, EventArgs e)
		{
			int count = 0;
			string[] styles =
				{
					"style=\"background-color: #A2E3F7\"; color: \"#FFFFFF\"",
					"style=\"background-color: #5EC6ED\"; color: \"#000000\""
				};

			StringBuilder sb = new StringBuilder();
			sb.Append( "<table style=\"border: thin solid #000000\" cellspacing='0' cellpadding='0'>" );
			foreach ( string message in TraceDT.GetMessages(true, MyWorkflowID) ) 
			{
				sb.Append( "<tr>\n" );
				sb.Append( "<td " );
				sb.Append( styles[count % 2] );
				sb.Append(">\n" );
				sb.Append( message );
				sb.Append( "</td>\n" );
				sb.Append( "</tr>\n" );

				count++;
			}
			sb.Append( "</table>" );
			LabelContent.Text = sb.ToString();
		}

		public static Guid MyWorkflowID
		{
			get
			{
				Guid? wfID = (Guid?)HttpContext.Current.Session["workflowID"];
				if ( wfID == null )
				{
					return Guid.Empty;
				}
				else
				{
					return (Guid)wfID;
				}
			}
			set
            {
				HttpContext.Current.Session["workflowID"] = value;
            }
		}
	}
}