﻿using System;
using System.Workflow.ComponentModel;
using WorkflowCore.Logging;
using WorkflowCore.Data;

//////////////////////////////////////////////////////////////////////
// Created by Michael Kennedy
// http://www.michaelckennedy.net
// Copyright Michael Kennedy 2008.
// Part of the HRWorkflow sample application featured in MSDN Magazine.
//

namespace WorkflowCore
{
	public partial class AssignJobActivity : AsyncActivity
	{
		public const string QUEUE_NAME = "AssignJobQueue";

		public AssignJobActivity()
			: base( QUEUE_NAME )
		{
			InitializeComponent();
		}

		protected override ActivityExecutionStatus Execute(ActivityExecutionContext ctx)
		{
			TraceDT.Add( "Execution beginning, waiting on queue.", 
				this.WorkflowInstanceId, this.GetType() );

			SubscribeToItemAvailable( ctx );
			return ActivityExecutionStatus.Executing;
		}

		protected override void OnQueueItemAvailable(ActivityExecutionContext ctx)
		{
			Job job = (Job)GetQueue( ctx ).Dequeue();
			TraceDT.Add( "Execution completing, queue item available: Assigned job {0} at {1}.", 
				this.WorkflowInstanceId, this.GetType(), job.JobTitle, job.Salary );

			// Assign job to employee, save in DB.
			Employee employee = Database.FindEmployee( this.WorkflowInstanceId );
			employee.Job = job.JobTitle;
			employee.Salary = job.Salary;
		}
	}
}
