﻿using System;
using System.Workflow.ComponentModel;
using WorkflowCore.Logging;
using WorkflowCore.Data;

//////////////////////////////////////////////////////////////////////
// Created by Michael Kennedy
// http://www.michaelckennedy.net
// Copyright Michael Kennedy 2008.
// Part of the HRWorkflow sample application featured in MSDN Magazine.
//

namespace WorkflowCore
{
	public partial class GatherEmployeeInfoActivity : AsyncActivity
	{
		public const string QUEUE_NAME = "GatherInfoQueue";

		public Employee Employee { get; set; }

		public GatherEmployeeInfoActivity()
			: base( QUEUE_NAME )
		{
			InitializeComponent();
		}

		protected override ActivityExecutionStatus Execute(ActivityExecutionContext ctx)
		{
			TraceDT.Add( "Execution beginning, waiting on queue.", 
				this.WorkflowInstanceId, this.GetType() );

			SubscribeToItemAvailable( ctx );
			return ActivityExecutionStatus.Executing;
		}

		protected override void OnQueueItemAvailable(ActivityExecutionContext ctx)
		{
			Employee employee = (Employee)GetQueue(ctx).Dequeue();

			TraceDT.Add( "Execution completing, queue item available: New prospect: {0}.", 
				this.WorkflowInstanceId, this.GetType(), employee.Name );
			
			// Store data in DB
			Database.SaveEmployee( this.WorkflowInstanceId, employee );
		}
	}
}
